Overview | Package | Class | Deprecated | Index | Help
| Groovy 1.7.6
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## groovy.servlet
[Java] Class TemplateServlet

    java.lang.Object
      javax.servlet.GenericServlet
          javax.servlet.http.HttpServlet
              groovy.servlet.AbstractHttpServlet
                  groovy.servlet.TemplateServlet

    public class TemplateServlet
    extends AbstractHttpServlet

A generic servlet for serving (mostly HTML) templates.

It delegates work to a `groovy.text.TemplateEngine` implementation processing HTTP requests.

#### Usage

`helloworld.html` is a headless HTML-like template

      <html>
        <body>
          <% 3.times { %>
            Hello World!
          <% } %>
          <br>
        </body>
      </html>

Minimal `web.xml` example serving HTML-like templates

     <web-app>
       <servlet>
         <servlet-name>template</servlet-name>
         <servlet-class>groovy.servlet.TemplateServlet</servlet-class>
       </servlet>
       <servlet-mapping>
         <servlet-name>template</servlet-name>
         <url-pattern>*.html</url-pattern>
       </servlet-mapping>
     </web-app>

#### Template engine configuration

By default, the TemplateServer uses the SimpleTemplateEngine which interprets JSP-like templates. The init parameter `template.engine` defines the fully qualified class name of the template to use:

       template.engine = [empty] - equals groovy.text.SimpleTemplateEngine
       template.engine = groovy.text.SimpleTemplateEngine
       template.engine = groovy.text.GStringTemplateEngine
       template.engine = groovy.text.XmlTemplateEngine

### Servlet Init Parameters

#### Logging and extra-output options

This implementation provides a verbosity flag switching log statements. The servlet init parameter name is:

       generated.by = true(default) | false

#### Groovy Source Encoding Parameter

The following servlet init parameter name can be used to specify the encoding TemplateServlet will use to read the template groovy source files:

       groovy.source.encoding

Authors:
  Christian Stein
  Guillaume Laforge

Version:
  2.0

See Also:
  TemplateServlet.setVariables

Field Summary

Fields inherited from class AbstractHttpServlet
CONTENT_TYPE_TEXT_HTML, INC_PATH_INFO, INC_REQUEST_URI, INC_SERVLET_PATH, encoding, reflection, resourceNameMatcher, resourceNameReplaceAll, resourceNameReplacement, servletContext, verbose

Method Summary
`def` | `TemplateServlet()` Create new TemplateSerlvet.
`protected Template` | `getTemplate(File file)` Gets the template created by the underlying engine parsing the request.
`void` | `init(ServletConfig config)` Initializes the servlet from hints the container passes.
`protected TemplateEngine` | `initTemplateEngine(ServletConfig config)` Creates the template engine.
`void` | `service(HttpServletRequest request, HttpServletResponse response)` Services the request with a response.

Methods inherited from class AbstractHttpServlet
getResourceConnection, getScriptUri, getScriptUriAsFile, init, setVariables

Methods inherited from class HttpServlet
service, log, log, init, init, destroy, getInitParameter, getInitParameterNames, getServletName, getServletContext, getServletConfig, getServletInfo, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll

Methods inherited from class GenericServlet
log, log, init, init, destroy, service, getInitParameter, getInitParameterNames, getServletName, getServletContext, getServletConfig, getServletInfo, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll

Methods inherited from class Object
wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll

Method Detail

### TemplateServlet

    public def TemplateServlet()

  Create new TemplateSerlvet.

### getTemplate

    protected Template getTemplate(File file)

  Gets the template created by the underlying engine parsing the request.

  This method looks up a simple (weak) hash map for an existing template object that matches the source file. If the source file didn't change in length and its last modified stamp hasn't changed compared to a precompiled template object, this template is used. Otherwise, there is no or an invalid template object cache entry, a new one is created by the underlying template engine. This new instance is put to the cache for consecutive calls.

  throws:
    ServletException If the request specified an invalid template source file
  Parameters:
    `file` - The HttpServletRequest.
  Returns:
    The template that will produce the response text.

### init

    public void init(ServletConfig config)

  Initializes the servlet from hints the container passes.

  Delegates to sub-init methods and parses the following parameters:

  - `"generatedBy"` : boolean, appends "Generated by ..." to the HTML response text generated by this servlet.
  throws:
    ServletException if this method encountered difficulties
  Parameters:
    `config` - Passed by the servlet container.
  See Also:
    TemplateServlet.initTemplateEngine

### initTemplateEngine

    protected TemplateEngine initTemplateEngine(ServletConfig config)

  Creates the template engine. Called by TemplateServlet.init and returns just `new groovy.text.SimpleTemplateEngine()` if the init parameter `template.engine` is not set by the container configuration.
  Parameters:
    `config` - Current serlvet configuration passed by the container.
  Returns:
    The underlying template engine or `null` on error.

### service

    public void service(HttpServletRequest request, HttpServletResponse response)

  Services the request with a response.

  First the request is parsed for the source file uri. If the specified file could not be found or can not be read an error message is sent as response.

  throws:
    IOException if an input or output error occurs while the servlet is handling the HTTP request
  throws:
    ServletException if the HTTP request cannot be handled
  Parameters:
    `request` - The http request.
    `response` - The http response.

Copyright © 2003-2010 The Codehaus. All rights reserved.